import java.awt.Panel;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.Color;
import java.awt.Graphics;

abstract class KomplexPanel extends Panel implements MouseListener {
	int    colorstyle=2;
	double x_mid=0;
	double y_mid=0;
	double pixel=0.009;
	double ytop;
	double xleft;
	
	public KomplexPanel(){
		super();
		addMouseListener(this);
		this.setBackground(new Color(0,0,0));
	}
	
	public void mouseClicked(MouseEvent arg0)  {
		if (arg0.getButton()==1){
			x_mid += arg0.getX()*pixel - pixel*this.getWidth()/2;
			y_mid -= arg0.getY()*pixel - pixel*this.getHeight()/2;
			pixel *= 0.5;
			repaint();
		}
		if (arg0.getButton()==3){
			pixel *= 2;
			repaint();
		}		
	}
	abstract int iter_komplex(double i_re, double i_im);
	
	public Color colorize(int res){
		switch(colorstyle){
			case 1:
				return new Color((255-res)%32*8,(255-res)%16*16,(255-res)%8*32);
			case 2:
				return new Color(res%32*8,res%16*16,res%8*32);
			case 3:
				return new Color(res,0,0);
			case 4:
				return new Color((int)(Math.log((double)res+1)*45.9),0,0);				
			case 5:
				return new Color((int)((double)(255-res)*(double)(255-res)/(double)65025),0,0);
			default:
				if (res==255){
					return Color.BLACK;
				}else{
					return Color.WHITE;
				}
		}
	}	
	
	public void paint (Graphics g){
		int res;
		ytop  = y_mid + pixel*this.getHeight()/2;
		xleft = x_mid - pixel*this.getWidth()/2;
	
		for (int x=0;x<this.getWidth();x++){
			for (int y=0;y<this.getHeight();y++){
				res = iter_komplex(xleft+x*pixel,ytop-y*pixel);
				g.setColor(colorize(res));
				g.drawLine(x,y,x,y);
			}
		}
		g.setColor(Color.RED);
		g.drawString("x=["+((double)(int)(xleft*1000)/1000)+".."+((double)(int)((xleft+pixel*this.getWidth())*1000)/1000)+"]",1,11);
		g.drawString("y=["+((double)(int)((ytop-pixel*this.getHeight())*1000)/1000)+"i.."+((double)(int)(ytop*1000)/1000)+"i]",1,24);
	}
	
	
	public void mouseEntered(MouseEvent arg0)  {}
	public void mouseExited(MouseEvent arg0)   {}
	public void mouseMoved(MouseEvent arg0)    {}
	public void mousePressed(MouseEvent arg0)  {}
	public void mouseReleased(MouseEvent arg0) {}
}
